import java.util.*;
import java.io.*;

public class I {

	List<Integer>[] graph;
	List<Integer> order = new ArrayList<>();
	boolean[] vis;
	
	
	void dfs(int u) {
		vis[u] = true;
		for (int v : graph[u]) {
			if (!vis[v]) {
				dfs(v);
			}
		}
		order.add(u);
	}
	
	void solve() {
		int n = in.nextInt(), m = in.nextInt();
		graph = new List[n];
		for (int i = 0; i < n; i++) {
			graph[i] = new ArrayList<>();
		}
		vis = new boolean[n];
		int[] from = new int[m], to = new int[m];
		for (int i = 0; i < m; i++) {
			from[i] = in.nextInt() - 1;
			to[i] = in.nextInt() - 1;
			graph[from[i]].add(to[i]);
		}
		for (int i = 0; i < n; i++) {
			if (!vis[i]) {
				dfs(i);
			}
		}
		Collections.reverse(order);
//		System.err.println(order);
		int[] pos = new int[n];
		for (int i = 0; i < n; i++) {
			pos[order.get(i)] = i;
		}
		boolean[] seen = new boolean[n - 1];
		int cnt = 0;
		for (int i = 0; i < m; i++) {
			if (pos[to[i]] - pos[from[i]] == 1) {
				if (!seen[pos[from[i]]]) {
					cnt++;
				}
				seen[pos[from[i]]] = true;
				if (cnt == n - 1) {
					out.println(i + 1);
					return;
				}
			}
		}
		out.println(-1);
	}

	FastScanner in;
	PrintWriter out;

	void run() {
		in = new FastScanner();
		out = new PrintWriter(System.out);
		solve();
		out.close();
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}

		public FastScanner(String s) {
			try {
				br = new BufferedReader(new FileReader(s));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		public String nextToken() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextToken());
		}

		public long nextLong() {
			return Long.parseLong(nextToken());
		}

		public double nextDouble() {
			return Double.parseDouble(nextToken());
		}
	}

	public static void main(String[] args) {
		new I().run();
	}
}
