#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <ctime>
#include <string>
#include <algorithm>
#include <queue>
#include <cstring>
#include <set>
#include <unordered_set>

using namespace std;

#define pii pair <int, int>

const int N = 2e3;

pii v[N];
int c;

int gcd(int a, int b)
{
	while (b)
	{
		c = a % b;
		a = b;
		b = c;
	}
	return a < 0 ? -a : a;
}

struct fraction
{
	int numerator;
	int denominator;
	int id;
	bool operator < (const fraction &a)
	{
		return ((long long)numerator) * a.denominator < ((long long)a.numerator) * denominator;
	}
	bool operator > (const fraction &a)
	{
		return ((long long)numerator) * a.denominator > ((long long)a.numerator) * denominator;
	}
	void relax()
	{
		int g = gcd(denominator, numerator);
		numerator /= g;
		denominator /= g;
	}
	fraction& operator -=(const fraction &x)
	{
		//make sure it will not overflow.
		numerator *= x.denominator;
		numerator -= x.numerator * denominator;
		denominator *= x.denominator;
		relax();
		return *this;
	}
	fraction& operator +=(const fraction &x)
	{
		//make sure it will not overflow.
		numerator *= x.denominator;
		numerator += x.numerator * denominator;
		denominator *= x.denominator;
		relax();
		return *this;
	}
};

fraction median(const fraction &a, const fraction &b)
{
	fraction c = { a.numerator + b.numerator, a.denominator + b.denominator };
	c.relax();
	return c;
}

fraction sum[N][N];
fraction arr[N];

fraction operator + (const fraction &a, const fraction &b)
{
	fraction c = a;
	c += b;
	return c;
}

fraction operator - (const fraction &a, const fraction &b)
{
	fraction c = a;
	c -= b;
	return c;
}

inline bool cmp(const pii &a, const pii &b)
{
	return a.first * b.second < a.second * b.first;
}

fraction rect[N][N];
pair <int, int> pref[N][N];
pair <int, int> pref2[N][N];

int main()
{
	::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
		scanf("%d%d", &v[i].first, &v[i].second),
		arr[i] = { v[i].first, v[i].second, i };

	sort(arr, arr + k);
	fraction ans = { -10000, 1 };

	for (int a = 0; a < k; a++)
		for (int b = a; b < k; b++)
		{
		    if (a == b)
		        rect[a][b] = ans;
		    else
			    rect[a][b] = median(arr[a], arr[b]);
			pref[a][b] = { a, b };
			pref2[a][b] = { a, b };
		}
	for (int i = 0; i < k; i++)
	{
		if (i != 0)
			pref[i][i] = pref[i - 1][i];
		for (int j = i + 1; j < k; j++)
		{
			if (i > 0)
			{
				int id1 = pref[i][j].first;
				int id2 = pref[i][j].second;
				int id3 = pref[i - 1][j].first;
				int id4 = pref[i - 1][j].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref[i][j] = { id3, id4 };
				id1 = pref2[i][j].first;
				id2 = pref2[i][j].second;
				id3 = pref2[i - 1][j].first;
				id4 = pref2[i - 1][j].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref2[i][j] = { id3, id4 };
			}
			if (j > i + 1)
			{
				int id1 = pref[i][j].first;
				int id2 = pref[i][j].second;
				int id3 = pref[i][j - 1].first;
				int id4 = pref[i][j - 1].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref[i][j] = { id3, id4 };
			}
		}
	}

	fraction Null = { 0, 1 };
	vector <int> answer;
	for (int i = 1; i < k; i++)
	{
		int id1 = pref[i - 1][i - 1].first;
		int id2 = pref[i - 1][i - 1].second;
		fraction cur = rect[id1][id2];
		for (int j = i + 1; j < k; j++)
		{
			if (Null < cur)
				if (ans < cur - rect[i][j])
				{
					ans = cur - rect[i][j];
					answer = { arr[id1].id, arr[i].id, arr[id2].id, arr[j].id };
				}
			int id3 = pref2[i - 1][j].first;
			int id4 = pref2[i - 1][j].second;
			if (cur < rect[id3][id4])
			{
				cur = rect[id3][id4];
				id1 = id3;
				id2 = id4;
			}
		}
	}
	for (int i = 0; i < 4; ++i)
		cout << answer[i] + 1 << " ";
	//cout << (ans.numerator + .0) / (ans.denominator) << endl;

	return 0;
}
