/**
 *    author:  [itmo] enot.1.10
 *    created: 17.10.2016 18:54:54       
**/
#define __USE_MINGW_ANSI_STDIO 0
#include <bits/stdc++.h>
 
#define F first
#define S second
#define pb push_back
#define mp make_pair
#define forn(i, n) for(int i = 0 ; (i) < (n) ; ++i)
#define eprintf(...) fprintf(stderr, __VA_ARGS__),fflush(stderr)
#define sz(a) ((int)(a).size())
#define all(a) (a).begin(),a.end()
#define pw(x) (1LL<<(x))
 
using namespace std;
 
typedef long long ll;
typedef double dbl;
typedef vector<int> vi;
typedef pair<int, int> pi;
 
const int inf = 1.01e9;
const dbl eps = 1e-9;
 
/* --- main part --- */
 
 
struct rat
{
    ll x, y;
    int id;
    rat(){}
    rat(ll xx, ll yy, int iid): x(xx), y(yy), id(iid) {}
    void norm()
    {
        ll g = __gcd(x, y);
        x /= g;
        y /= g;
        if (y < 0) x = -x, y = -y;
    }
};
 
inline rat merge(rat a, rat b)
{
    return rat(a.x + b.x, a.y + b.y, -1);
}
 
inline rat operator - (rat a, rat b)
{
    return rat(a.x * b.y - a.y * b.x, a.y * b.y, -1);
}
 
inline bool operator < (rat a, rat b)
{
    return a.x * b.y < a.y * b.x;
}
 
const int N = 2010;
 
rat a[N];
int n;
 
int d2[N][N];
int d3[N][N];
 
 
int main()
{
    #ifdef home
        assert(freopen("1.in", "r", stdin));
        assert(freopen("1.out", "w", stdout));
    #endif
    scanf("%d", &n);
    forn(i, n)
    {
        int x, y;
        scanf("%d%d", &x, &y);
        a[i] = rat(x, y, i + 1);
    }
    sort(a, a + n);
    for (int i3 = 1; i3 < n; ++i3)
    {
        d3[i3][1] = 0;
        for (int i2 = 2; i2 <= i3; ++i2)
        {
            int i1 = i2 - 1;
            d3[i3][i2] = d3[i3][i1];
            if (merge(a[i3], a[d3[i3][i2]]) < merge(a[i3], a[i1]))
            {
                d3[i3][i2] = i1;
            }
        }
    }
    for (int i2 = 1; i2 < n - 1; ++i2)
    {
        d2[i2][n - 2] = n - 1;
        for (int i3 = n - 3; i3 >= i2; --i3)
        {
            int i4 = i3 + 1;
            d2[i2][i3] = d2[i2][i4];
            if (merge(a[i2], a[i4]) < merge(a[i2], a[d2[i2][i3]]))
            {
                d2[i2][i3] = i4;
            }
        }
    }
 
    rat res = rat(-inf, 1, -1);
    int r1 = 0, r2 = 0, r3 = 0, r4 = 0;
 
    for (int i2 = 1; i2 < n - 1; ++i2) for (int i3 = 1; i3 < n - 1; ++i3) if (i2 != i3)
    {
        int mn = min(i2, i3);
        int mx = max(i2, i3);
        rat val = merge(a[i3], a[d3[i3][mn]]) - merge(a[i2], a[d2[i2][mx]]);
        if (res < val)
        {
            res = val;
            r1 = d3[i3][mn];
            r2 = i2;
            r3 = i3;
            r4 = d2[i2][mx];
        }
    }

    //res.norm();
    eprintf("%I64d / %I64d\n", res.x, res.y);
 
    printf("%d %d %d %d\n", a[r1].id, a[r2].id, a[r3].id, a[r4].id);
 
     
    #ifdef home
        eprintf("time = %d ms\n", (int)(clock() * 1000. / CLOCKS_PER_SEC));
    #endif
    return 0;
}
