import java.util.*;
import java.io.*;

public class hitches_dp_hs {
    FastScanner in;
    PrintWriter out;

    private class Pair implements Comparable<Pair> {
      int first;
      int second;

      Pair(int first, int second) {
        this.first = first;
        this.second = second;
      }

      @Override
      public int compareTo(Pair p) {
        if (first != p.first) {
          return first - p.first;
        }
        return second - p.second;
      }

      @Override
      public boolean equals(Object o) {
        return (o instanceof Pair) && ((Pair)o).first == first && ((Pair)o).second == second;
      }

      @Override
      public int hashCode() {
        return first * 239 + second;
      }
    }

    public void solve() throws IOException {
      int nDetail = in.nextInt();
      int mDetail = in.nextInt();
      char[][] detail = new char[nDetail][];
      int cnt = 0;
      for (int i = 0; i < nDetail; i++) {
        detail[i] = in.next().toCharArray();
        for (int j = 0; j < mDetail; j++) {
          cnt += detail[i][j] == '*' ? 1 : 0;
        }
      }
      int nMold = in.nextInt();
      int mMold = in.nextInt();
      char[][] mold = new char[nMold][];
      for (int i = 0; i < nMold; i++) {
        mold[i] = in.next().toCharArray();
      }

      int maxn = 100000;
      int[] upperCell = new int[mMold];
      Arrays.fill(upperCell, -maxn);
      boolean[][] used = new boolean[nMold][mMold];
      for (int i = 0; i < nMold; i++) {
        for (int j = 0; j < mMold; j++) {
          if (mold[i][j] == '#') {
            upperCell[j] = Math.max(upperCell[j], nMold - i - 1);
            used[nMold - i - 1][j] = true;
          }
        }
      }
      int[] dcoordsx = new int[cnt];
      int[] dcoordsy = new int[cnt];
      int c = 0;
      for (int i = 0; i < nDetail; i++) {
        for (int j = 0; j < mDetail; j++) {
          if (detail[i][j] == '*') {
            dcoordsx[c] = nDetail - i - 1;
            dcoordsy[c] = j;
            c++;
          }
        }
      }
      int answer = 0;
      for (int shift = -mDetail + 1; shift <= mMold; shift++) {
        int[] dsx = new int[dcoordsx.length];
        int[] dsy = new int[dcoordsy.length];
        int moves = Integer.MAX_VALUE;
        boolean allDown = true;
        for (int i = 0; i < dsx.length; i++) {
          dsx[i] = dcoordsx[i] + nMold;
          dsy[i] = dcoordsy[i] + shift;
          int upper = (0 <= dsy[i] && dsy[i] < mMold) ? upperCell[dsy[i]] : -maxn;
          allDown &= (upper == -maxn);
          moves = Math.min(moves, dsx[i] - upper - 1);
        }
        if (allDown) {
          continue;
        }
        int hitches = 0;
        for (int i = 0; i < dsx.length; i++) {
          dsx[i] -= moves;
          hitches += (dsx[i] >= 0 && dsx[i] < nMold &&
                      dsy[i] - 1 >= 0 && dsy[i] - 1 < mMold &&
                      used[dsx[i]][dsy[i] - 1]) ? 1 : 0;
        }
        answer = Math.max(answer, hitches);
      }
      out.println(answer);
    }

    public void run() {
        try {
            in = new FastScanner();
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner() {
            try {
                br = new BufferedReader(new InputStreamReader(System.in));
            } catch (Exception e) {
                e.printStackTrace();
            }
        }

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new hitches_dp_hs().run();
    }
}

